var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
import Icon from 'awesome-react-icons';
import React, { useState } from 'react';
import tw from 'twin.macro';
export var Navigation = function (_a) {
    var activeItemId = _a.activeItemId, onSelect = _a.onSelect, items = _a.items;
    var _b = useState({
        expanded: true,
        selectedId: activeItemId,
    }), activeSubNav = _b[0], setActiveSubNav = _b[1];
    function handleClick(itemId) {
        if (onSelect) {
            onSelect({ itemId: itemId });
        }
    }
    function handleSubNavExpand(item) {
        if (activeSubNav.expanded) {
            var currentItemOrSubNavItemIsOpen = item.itemId === activeSubNav.selectedId ||
                (item.subNav &&
                    item.subNav.some(function (_subNavItem) { return _subNavItem.itemId === activeSubNav.selectedId; })) ||
                false;
            setActiveSubNav({
                expanded: !currentItemOrSubNavItemIsOpen,
                selectedId: item.itemId,
            });
        }
        else {
            setActiveSubNav({
                expanded: true,
                selectedId: item.itemId,
            });
        }
    }
    return (React.createElement(React.Fragment, null, items.map(function (item) {
        var ElemBefore = item.elemBefore;
        return (React.createElement("ul", { key: item.itemId, className: "side-navigation" },
            React.createElement("li", null,
                React.createElement("div", { onClick: function () {
                        return item.subNav
                            ? handleSubNavExpand(item)
                            : handleClick(item.itemId);
                    }, css: [
                        tw(templateObject_1 || (templateObject_1 = __makeTemplateObject(["hover:bg-gray-100 hover:text-gray-800 hover:border-pink-500 focus:outline-none flex items-center justify-between w-full px-6 py-3 text-gray-700 border-l-2 cursor-pointer"], ["hover:bg-gray-100 hover:text-gray-800 hover:border-pink-500 focus:outline-none flex items-center justify-between w-full px-6 py-3 text-gray-700 border-l-2 cursor-pointer"]))),
                        activeSubNav.selectedId === item.itemId && tw(templateObject_2 || (templateObject_2 = __makeTemplateObject(["text-gray-800 bg-gray-100 border-pink-500"], ["text-gray-800 bg-gray-100 border-pink-500"]))),
                    ], className: "main-item" },
                    React.createElement("span", { className: "flex items-center" },
                        ElemBefore && React.createElement(ElemBefore, null),
                        React.createElement("span", { className: "mx-4 font-medium" }, item.title)),
                    item.subNav && item.subNav.length > 0 && (React.createElement(Icon, { name: !activeSubNav.expanded ? 'chevron-down' : 'chevron-up' })))),
            item.subNav &&
                (item.itemId === activeSubNav.selectedId ||
                    item.subNav.some(function (_subNavItem) {
                        return _subNavItem.itemId === activeSubNav.selectedId;
                    })) &&
                activeSubNav.expanded && (React.createElement("ul", { className: "sub-nav-item" }, item.subNav.map(function (subNavItem) {
                return (React.createElement("li", { key: subNavItem.itemId },
                    React.createElement("div", { onClick: function () { return handleClick(subNavItem.itemId); }, css: [
                            tw(templateObject_3 || (templateObject_3 = __makeTemplateObject(["hover:bg-gray-100 hover:text-gray-800 hover:border-pink-500 block px-16 py-2 text-sm text-gray-700 border-l-2 cursor-pointer"], ["hover:bg-gray-100 hover:text-gray-800 hover:border-pink-500 block px-16 py-2 text-sm text-gray-700 border-l-2 cursor-pointer"]))),
                            activeSubNav.selectedId === subNavItem.itemId && tw(templateObject_4 || (templateObject_4 = __makeTemplateObject(["text-gray-800 bg-gray-100 border-pink-500"], ["text-gray-800 bg-gray-100 border-pink-500"]))),
                        ], className: "sub-item" }, subNavItem.title)));
            })))));
    })));
};
var templateObject_1, templateObject_2, templateObject_3, templateObject_4;
